// ============================================================================================
// Datei:		main.cpp
//
// Desc:			main file: multhread2
//
// Coder:		Kongo
// Stand/Ver:	20.07.2001/0.0
// ============================================================================================


// ============================================================================================
// Libs
// ============================================================================================

#define WIN32_LEAN_AND_MEAN  // Kein MFC Zeugs *arg*

#include <windows.h>
#include <windowsx.h>
#include <stdio.h>

// --------------------------------------------------------------------------------------------


// ============================================================================================
// Definitionen
// ============================================================================================

#define MAX_THREADS 3 

// --------------------------------------------------------------------------------------------


// ============================================================================================
// Funktionen
// ============================================================================================

DWORD WINAPI ThreadFunc(LPVOID data)
{
	// Gibt 50 ein Zeichen mit einer Verzgerung aus

	for (int index=0; index<50; index++) {
		printf("%d ",(int)data+1);		// Wert ausgeben
		Sleep(100);							// Verzger ein bisschen das ganze
	} // end for index


	// gibt den Wert zurck den du bekommen hast
	return((DWORD)data);

} // end ThreadFunc

// --------------------------------------------------------------------------------------------

void main(void)
{

	HANDLE hThread[MAX_THREADS];			// Handles auf die Threads
	DWORD  dwThreadID[MAX_THREADS];		// IDs der Threads


	printf("\nAlle Threads starten...\n");

	// Alle Threads starten
	for (int index=0; index<MAX_THREADS; index++) {

		hThread[index] = CreateThread(NULL,						// Sicherheitsinfos
												0,							// Gre des Stack
			   								ThreadFunc,				// Threadfunktion
												(LPVOID)index,			// 32-bit paramter der Threadfunktion bergeben wird
												0,							// Creation Flags, 0=sofort starten.
												&dwThreadID[index]);	// Id speichern
	} // end for index


	// Hauptthread gibt nun auch Zeichen aus; Nur 25 dadurch weniger als die erzeugten Threads
	for (index=0; index<25; index++) {
		printf("4 ");
		Sleep(100);
	} // end for index

	// Auf die Threads warten, bis sie fertig sind
	WaitForMultipleObjects(	MAX_THREADS,	// Anzahl der Threads, auf die gewartete werden muss
									hThread,			// Handles der Threads
									TRUE,				// Fr alle warten?
									INFINITE);		// Wie lange soll gewartet werden, INFINITE = unendlich lange

	// Alle Threads sollten beendet sein

	for (index=0; index<MAX_THREADS; index++)
		CloseHandle(hThread[index]);

	printf("\nAlle Threads beendet.\n");

} // end main

// --------------------------------------------------------------------------------------------
